#include "SbPreCompile.h" //QFileDialog

#include "BrokenPrinter.h" //OptimizeRepair
#include "ui_BrokenPrinter.h" //OptimizeRepair

BrokenPrinter * BrokenPrinter::theSharedInstance=NULL; //The shared instance.

BrokenPrinter::BrokenPrinter(QWidget *parent) :QMainWindow(parent),ui(new Ui::BrokenPrinter)
{
    ui->setupUi(this);

    initializeMembers(); //初始化成员变量。


#ifdef Q_OS_ANDROID
    registerNativeMethods(); //注册原生方法。
#endif



    connectSignals(); //连接信号。

    return;
} //CellAutomator::CellAutomator(QWidget *parent) :QMainWindow(parent),ui(new Ui::CellAutomator)


#ifdef Q_OS_ANDROID

/*!
 * \brief OptimizeRepair::receiveUnknownPhoto 接收照片。未知照片。用于分组识别。
 * \param env 环境对象。
 * \param thiz 类对象。
 * \param applicationVersion 额外参数。
 */
void FacePlusPlusLearnQt::receiveUnknownPhotoForGroupIdentify(JNIEnv * env, jobject thiz , jint applicationVersion)
{
    Q_UNUSED(env);
    Q_UNUSED(thiz);
    Q_UNUSED(applicationVersion);

    QFile imageFile("/sdcard/facePhoto.jpg"); //照片文件。

    int randomNumber=qrand(); //随机数。

    QFile targetFile(tr("/sdcard/facePhoto%1.jpg").arg(randomNumber)); //目标文件。

    targetFile.remove (); //删除目标文件。

    imageFile.copy(tr("/sdcard/facePhoto%1.jpg").arg(randomNumber)); //复制文件。

    FacePlusPlusLearnQt * m_instance=FacePlusPlusLearnQt::sharedInstance();

    qDebug() << __FILE__ << __LINE__ << __func__ << tr("Copy target file name:") << tr("/sdcard/facePhoto%1.jpg").arg(randomNumber); //Debug.



    //开始探测：
    m_instance->emitShouldStartDetectForUnknownPhotoForGroupIdentify(tr("/sdcard/facePhoto%1.jpg").arg(randomNumber)); //发射信号，应当开始针对未知照片进行人脸检测。用于分组识别。


    return;
} //void OptimizeRepair::receiveUnknownPhoto(JNIEnv * env, jobject thiz , jint applicationVersion)

#endif


#ifdef Q_OS_ANDROID

/*!
 * \brief OptimizeRepair::receiveUnknownPhoto 接收照片。未知照片。
 * \param env 环境对象。
 * \param thiz 类对象。
 * \param applicationVersion 额外参数。
 */
void FacePlusPlusLearnQt::receiveUnknownPhoto(JNIEnv * env, jobject thiz , jint applicationVersion)
{
    Q_UNUSED(env);
    Q_UNUSED(thiz);
    Q_UNUSED(applicationVersion);

    QFile imageFile("/sdcard/facePhoto.jpg"); //照片文件。

    int randomNumber=qrand(); //随机数。

    QFile targetFile(tr("/sdcard/facePhoto%1.jpg").arg(randomNumber)); //目标文件。

    targetFile.remove (); //删除目标文件。

    imageFile.copy(tr("/sdcard/facePhoto%1.jpg").arg(randomNumber)); //复制文件。

    FacePlusPlusLearnQt * m_instance=FacePlusPlusLearnQt::sharedInstance();

    qDebug() << __FILE__ << __LINE__ << __func__ << tr("Copy target file name:") << tr("/sdcard/facePhoto%1.jpg").arg(randomNumber); //Debug.



    //开始探测：
    m_instance->emitShouldStartDetectForUnknownPhoto(tr("/sdcard/facePhoto%1.jpg").arg(randomNumber)); //发射信号，应当开始针对未知照片进行人脸检测。


    return;
} //void OptimizeRepair::receiveUnknownPhoto(JNIEnv * env, jobject thiz , jint applicationVersion)

#endif

/*!
 * \brief OptimizeRepair::emitShouldStartDetectForUnknownPhoto 发射信号，应当开始针对未知照片进行人脸检测。
 * \param trsdcardfacePhotojpgargrandomNumber 照片文件名。
 */
void BrokenPrinter::emitShouldStartDetectForUnknownPhotoForGroupIdentify(QString trsdcardfacePhotojpgargrandomNumber)
{
    emit shouldStartDetectForUnknownPhotoForGroupIdentify( trsdcardfacePhotojpgargrandomNumber); //发射信号。

    return;
} //void OptimizeRepair::emitShouldStartDetectForUnknownPhoto(QString trsdcardfacePhotojpgargrandomNumber)



#ifdef Q_OS_ANDROID

/*!
 * \brief OptimizeRepair::receivePhoto 接收照片。
 * \param env 环境对象。
 * \param thiz 类对象。
 * \param applicationVersion 额外参数。
 */
void FacePlusPlusLearnQt::receivePhotoForPerson(JNIEnv * env, jobject thiz , jint applicationVersion)
{
    Q_UNUSED(env);
    Q_UNUSED(thiz);
    Q_UNUSED(applicationVersion);

    QFile imageFile("/sdcard/facePhoto.jpg"); //照片文件。

    int randomNumber=qrand(); //随机数。

    QFile targetFile(tr("/sdcard/facePhoto%1.jpg").arg(randomNumber)); //目标文件。

    targetFile.remove (); //删除目标文件。

    imageFile.copy(tr("/sdcard/facePhoto%1.jpg").arg(randomNumber)); //复制文件。

    FacePlusPlusLearnQt * m_instance=FacePlusPlusLearnQt::sharedInstance();

    qDebug() << __FILE__ << __LINE__ << __func__ << tr("Copy target file name:") << tr("/sdcard/facePhoto%1.jpg").arg(randomNumber); //Debug.

    m_instance->rememberPhotoImageFileForPerson(tr("/sdcard/facePhoto%1.jpg").arg(randomNumber)); //记录图片文件名。

    return;

} //void OptimizeRepair::receivePhoto(JNIEnv * env, jobject thiz , jint applicationVersion)

#endif

#ifdef Q_OS_ANDROID

/*!
 * \brief OptimizeRepair::receivePhoto 接收照片。
 * \param env 环境对象。
 * \param thiz 类对象。
 * \param applicationVersion 额外参数。
 */
void FacePlusPlusLearnQt::receivePhoto(JNIEnv * env, jobject thiz , jint applicationVersion)
{
    Q_UNUSED(env);
    Q_UNUSED(thiz);
    Q_UNUSED(applicationVersion);

    QFile imageFile("/sdcard/facePhoto.jpg"); //照片文件。

    int randomNumber=qrand(); //随机数。

    QFile targetFile(tr("/sdcard/facePhoto%1.jpg").arg(randomNumber)); //目标文件。

    targetFile.remove (); //删除目标文件。

    imageFile.copy(tr("/sdcard/facePhoto%1.jpg").arg(randomNumber)); //复制文件。

    FacePlusPlusLearnQt * m_instance=FacePlusPlusLearnQt::sharedInstance();

    qDebug() << __FILE__ << __LINE__ << __func__ << tr("Copy target file name:") << tr("/sdcard/facePhoto%1.jpg").arg(randomNumber); //Debug.

    m_instance->rememberPhotoImageFile(tr("/sdcard/facePhoto%1.jpg").arg(randomNumber)); //记录图片文件名。

    return;

} //void OptimizeRepair::receivePhoto(JNIEnv * env, jobject thiz , jint applicationVersion)

#endif

#ifdef Q_OS_ANDROID

/*!
 * \brief FacePlusPlusLearnQt::registerNativeMethods 向JNI注册原生方法。
 */
void FacePlusPlusLearnQt::registerNativeMethods()
{
    JNINativeMethod methods[] {
                {"receivePhoto", "(I)V", reinterpret_cast<void *>(&FacePlusPlusLearnQt::receivePhoto)},
        {"receivePhotoForPerson", "(I)V", reinterpret_cast<void *>(&FacePlusPlusLearnQt::receivePhotoForPerson)},
        {"receiveUnknownPhoto", "(I)V", reinterpret_cast<void *>(&FacePlusPlusLearnQt::receiveUnknownPhoto)},
        {"receiveUnknownPhotoForGroupIdentify", "(I)V", reinterpret_cast<void *>(&FacePlusPlusLearnQt::receiveUnknownPhotoForGroupIdentify)},

    };

QAndroidJniObject javaClass("com/stupidbeauty/comgooglewidevinesoftwaredrmremover/app/X2AppSimpleActivity");
QAndroidJniEnvironment env;
    jclass objectClass = env->GetObjectClass(javaClass.object<jobject>());
    env->RegisterNatives(objectClass,
    methods,
    sizeof(methods) / sizeof(methods[0]));
    env->DeleteLocalRef(objectClass);
}

#endif

BrokenPrinter::~BrokenPrinter()
{
    delete ui;
}

void BrokenPrinter::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

/*!
 * \brief FacePlusPlusLearnQt::initializeMembers 初始化成员变量。
 */
void BrokenPrinter::initializeMembers()
{
    ui->oRscrollArea->viewport ()->setAttribute (Qt::WA_AcceptTouchEvents);
    QScroller::grabGesture(ui->oRscrollArea->viewport (),QScroller::LeftMouseButtonGesture);


    theSharedInstance=this; //记录单实例。


    return;
} //void CellAutomator::initializeMembers()

/*!
 * \brief CellAutomator::connectSignals 连接信号。
 */
void BrokenPrinter::connectSignals()
{

    return;
} //void CellAutomator::connectSignals()

/*!
 * \brief FacePlusPlusLearnQt::selectTextFile 选择文本文件。
 */
void BrokenPrinter::selectTextFile()
{
    QString fileName=QFileDialog::getOpenFileName(); //打开文件。

    if (fileName.isEmpty()) //取消。
    {

    } //if (fileName.isEmpty()) //取消。
    else //正确地选择了文件。
    {
        QFile textFile(fileName); //文件对象。

        textFile.open(QIODevice::ReadOnly); //打开文件。

        QTextStream textStream(&textFile); //文本流。

        QImage printerImage(768,1024,QImage::Format_RGB32); //打印机图片。
        printerImage.fill(Qt::white); //填充为白色。

        QPainter painter(&printerImage); //绘图器。

        while (!textStream.atEnd()) //尚未读取完毕。
        {
            QString currentLine=textStream.readLine(); //读取一行。

            painter.drawText(0,100,currentLine); //绘制文字。
        } //while (!textStream.atEnd()) //尚未读取完毕。

        painter.end(); //终止绘图。

        QPixmap printerPixmap=QPixmap::fromImage(printerImage); //转换成位图。

        ui->imglabel->setPixmap(printerPixmap); //显示图片。


        textFile.close(); //关闭文件。

    } //else //正确地选择了文件。

    return;
} //void FacePlusPlusLearnQt::selectTextFile()

/*!
 * \brief OptimizeRepair::checkCameraAvailability 检测相机。
 */
bool BrokenPrinter::checkCameraAvailability()
{
    if (QCameraInfo::availableCameras().count()>0)
    {
        return true;
    } //if (QCameraInfo::availableCameras().count()>0)
    else
    {
        return false;
    } //else

} //void OptimizeRepair::checkCameraAvailability()

/*!
 * \brief OptimizeRepair::takeOneUnknownPhoto 拍摄一张未知照片。
 */
void BrokenPrinter::takeOneUnknownPhoto()
{
#ifdef Q_OS_ANDROID
    jniTakeOneUknownPhoto(); //以JNI方式来拍摄照片。未知照片。
#endif

    return;
} //void OptimizeRepair::takeOneUnknownPhoto()

/*!
 * \brief OptimizeRepair::takeOnePhoto 拍摄一张照片。
 */
void BrokenPrinter::takeOnePhoto()
{

#ifdef Q_OS_ANDROID
    jniTakeOnePhoto(); //以JNI方式来拍摄照片。
#endif


    return;
} //void OptimizeRepair::takeOnePhoto()

#ifdef Q_OS_ANDROID

/*!
 * \brief OptimizeRepair::jniTakeOneUknownPhoto 以JNI方式来拍摄照片。未知照片。
 */
void FacePlusPlusLearnQt::jniTakeOneUknownPhotoForGroupIdentify()
{
    QAndroidJniObject stringArray = QAndroidJniObject :: callStaticObjectMethod ("com.stupidbeauty.comgooglewidevinesoftwaredrmremover.app.X2AppSimpleActivity",
    "takeOneUnknownPhotoForGroupIdentify",
    "()Ljava/lang/String;"
    );

    return;
} //void OptimizeRepair::jniTakeOneUknownPhoto()

#endif




#ifdef Q_OS_ANDROID

/*!
 * \brief OptimizeRepair::jniTakeOneUknownPhoto 以JNI方式来拍摄照片。未知照片。
 */
void FacePlusPlusLearnQt::jniTakeOneUknownPhoto()
{
    QAndroidJniObject stringArray = QAndroidJniObject :: callStaticObjectMethod ("com.stupidbeauty.comgooglewidevinesoftwaredrmremover.app.X2AppSimpleActivity",
    "takeOneUnknownPhoto",
    "()Ljava/lang/String;"
    );

    return;
} //void OptimizeRepair::jniTakeOneUknownPhoto()

#endif


#ifdef Q_OS_ANDROID

/*!
 * \brief OptimizeRepair::jniTakeOnePhoto 以JNI方式来拍摄照片。
 */
void FacePlusPlusLearnQt::jniTakeOnePhotoForPerson()
{
    QAndroidJniObject stringArray = QAndroidJniObject :: callStaticObjectMethod ("com.stupidbeauty.comgooglewidevinesoftwaredrmremover.app.X2AppSimpleActivity",
    "takeOnePhotoForPerson",
    "()Ljava/lang/String;"
    );

    return;
} //void OptimizeRepair::jniTakeOnePhoto()

#endif


#ifdef Q_OS_ANDROID

/*!
 * \brief OptimizeRepair::jniTakeOnePhoto 以JNI方式来拍摄照片。
 */
void FacePlusPlusLearnQt::jniTakeOnePhoto()
{
    QAndroidJniObject stringArray = QAndroidJniObject :: callStaticObjectMethod ("com.stupidbeauty.comgooglewidevinesoftwaredrmremover.app.X2AppSimpleActivity",
    "takeOnePhoto",
    "()Ljava/lang/String;"
    );

    return;
} //void OptimizeRepair::jniTakeOnePhoto()

#endif
