package com.stupidbeauty.comgooglewidevinesoftwaredrmremover.app;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.support.v4.content.LocalBroadcastManager;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
import android.net.ConnectivityManager;
import java.lang.reflect.Method;
import com.stupidbeauty.comgooglewidevinesoftwaredrmremover.BlueActivity;
import com.stupidbeauty.comgooglewidevinesoftwaredrmremover.BlueController;
import com.stupidbeauty.comgooglewidevinesoftwaredrmremover.Constants;
import android.net.Uri;
import android.content.Intent;
import android.provider.MediaStore;
import java.io.File;



import com.stupidbeauty.comgooglewidevinesoftwaredrmremover.R;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager.NameNotFoundException;


/**
 * The main activity.
 */
public class X2AppSimpleActivity extends BlueActivity
{
	private static X2AppSimpleActivity m_instance; //!<The single instance object.
	private static int simSlotNumber=0; //!<Selected sim slot number.

  static final int REQUEST_IMAGE_CAPTURE = 1;
  private static Uri mLocationForPhotos; //!<存储照片的位置。

  private native void receivePhoto(int dumbParameter); //!<接收照片。

  public static void capturePhoto(String targetFilename) {
  Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
  intent.putExtra(MediaStore.EXTRA_OUTPUT,Uri.withAppendedPath(mLocationForPhotos, targetFilename));
  m_instance.startActivityForResult(intent, REQUEST_IMAGE_CAPTURE);
  }


  @Override
  protected void onActivityResult(int requestCode, int resultCode, Intent data)
  {
  if (requestCode == REQUEST_IMAGE_CAPTURE && resultCode == RESULT_OK) {

    //调用C++代码，对照片进行处理：
    receivePhoto(0); //接收照片。
  }
  }


	@Override
	/**
	 * 此活动正在被创建。
	 */
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);

    registerBroadcastReceiver();

    File sdcardFile=new File("/sdcard/");

    mLocationForPhotos=Uri.fromFile(sdcardFile);



    return;
	} //protected void onCreate(Bundle savedInstanceState)
  
	/**
	 * 注册广播事件接收器。
	 */
	private void registerBroadcastReceiver() 
	{
		IntentFilter intentFilter = new IntentFilter(); //创建意图过滤器。
		
		intentFilter.addAction(Constants.NativeMessage.STATUS_TEXT_CHANGE); //status text change。
    intentFilter.addAction(Constants.NativeMessage.SHARE_TEXT); //分享文字内容。
    intentFilter.addAction(Constants.NativeMessage.QUERY_VERSION); //查询应用程序版本号。

		LocalBroadcastManager lclBrdcstMngr=LocalBroadcastManager.getInstance(this); //Get the broadcast manager instance.
		lclBrdcstMngr.registerReceiver(mBroadcastReceiver, intentFilter); //注册接收器。
		
		return;
	} //private void registerBroadcastReceiver()
	
	/**
	 * 广播接收器。
	 */
	private BroadcastReceiver mBroadcastReceiver = new BroadcastReceiver() 
	{
		@Override
		/**
		 * 接收到广播。
		 */
		public void onReceive(Context context, Intent intent) 
		{
			String action = intent.getAction(); //获取广播中带的动作字符串。
			
			if (Constants.NativeMessage.STATUS_TEXT_CHANGE.equals(action)) //status text change. 
			{
				Bundle extras=intent.getExtras(); //获取参数包。
				String statusText=extras.getString(Constants.NativeMessage.STATUS_TEXT_KEY); //获取状态文字。
				


			} //if (Constants.NativeMessage.NOTIFY_CHARGGING_STATE.equals(action)) //电池充电状态变化。
      else if (Constants.NativeMessage.SHARE_TEXT.equals(action)) //分享文字内容。
      {
        Bundle extras=intent.getExtras(); //获取参数包。
        String statusText=extras.getString(Constants.NativeMessage.SHARE_TEXT_KEY); //获取状态文字。


        shareText(statusText); //分享文字内容。


      } //if (Constants.NativeMessage.NOTIFY_CHARGGING_STATE.equals(action)) //电池充电状态变化。
      else if (Constants.NativeMessage.QUERY_VERSION.equals(action)) //查询应用程序版本号。
      {
        queryVersion(); //查询应用程序版本号。
      } //if (Constants.NativeMessage.NOTIFY_CHARGGING_STATE.equals(action)) //电池充电状态变化。

		} //public void onReceive(Context context, Intent intent)
	}; //private BroadcastReceiver mBroadcastReceiver = new BroadcastReceiver()
	
	
  public void shareText(String statusText) //分享文字内容。
  {
        Intent sendIntent = new Intent(); //创建意图对象。
        sendIntent.setAction(Intent.ACTION_SEND); //设置意图类型。
        sendIntent.putExtra(Intent.EXTRA_TEXT, statusText) ; //设置文字。
        sendIntent.setType("text/plain"); //设置内容类型。
        startActivity(sendIntent); //启动意图。

        return;
    } //public void shareText(statusText)

    /**
    * 查询应用程序版本号。
    */
  public void queryVersion()
  {
      try {
    PackageInfo pi = getPackageManager().getPackageInfo(getPackageName(), 0);      
    String versionName=pi.versionName ;     //获取版本号名字。
    
        BlueController controller=BlueController.sharedInstance();

    controller.reportVersion(versionName); //报告版本号。
} catch (NameNotFoundException e) {
        e.printStackTrace();

}


    
    return;
  } //public void shareText(statusText)

	/**
	 * Constructor.
	 */
	public X2AppSimpleActivity()
	{
		m_instance=this; //Remember the single instance object.

		return;
	} //public X2AppSimpleActivity()

	/**
	 * @brief Get the imei string.
	 */
	public static String getImeiString()
	{
		System.out.println("getImeiString got invoked"); //Debug.

		String result=""; //Result.


		TelephonyInfo telephonyInfo = TelephonyInfo.getInstance(m_instance);

		String imeiSIM1 = telephonyInfo.getImeiSIM1();

		result=imeiSIM1;




		return result;
	} //public static String getImeiString()



  /**
   * @brief Get the imei string.
   */
  public static String takeOnePhoto()
  {
    System.out.println("takeOnePhoto got invoked"); //Debug.

    String result=""; //Result.

    capturePhoto("facePhoto.jpg");





    return result;
  } //public static String getImeiString()


	/**
	 * @brief Show toast.
	 */
	public static String showToast(final String toastString)
	{

		System.out.println("showToast got invoked"); //Debug.

		String result=""; //Result.


		m_instance.runOnUiThread
		(
				new Runnable()
				{


					public void run()
					{
						Toast.makeText(m_instance, toastString, Toast.LENGTH_LONG).show();   //show toast as requested.

					}
				}
				);



		return result;
	}






	/**
	 * 	Goto the home screen.
	 */
	public static String gotoHomeScreen()
	{
		String result="OK";
		System.out.println("gotoHomeScreen got invoked"); //Debug.

		Intent homeIntent=new Intent(); //Create the intent.

		homeIntent.setAction(Intent.ACTION_MAIN);
		homeIntent.addCategory(Intent.CATEGORY_HOME);

		m_instance.startActivity(homeIntent);

		return result;
	} //public void startVsimNetwork()





}
